/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignPatchableTargetChannelsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignPatchableTargetChannelsInner{}

// CampaignPatchableTargetChannelsInner struct for CampaignPatchableTargetChannelsInner
type CampaignPatchableTargetChannelsInner struct {
	ChannelId string `json:"channel_id"`
	InteractionId string `json:"interaction_id"`
	Main *bool `json:"main,omitempty"`
}

// NewCampaignPatchableTargetChannelsInner instantiates a new CampaignPatchableTargetChannelsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignPatchableTargetChannelsInner(channelId string, interactionId string) *CampaignPatchableTargetChannelsInner {
	this := CampaignPatchableTargetChannelsInner{}
	this.ChannelId = channelId
	this.InteractionId = interactionId
	return &this
}

// NewCampaignPatchableTargetChannelsInnerWithDefaults instantiates a new CampaignPatchableTargetChannelsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignPatchableTargetChannelsInnerWithDefaults() *CampaignPatchableTargetChannelsInner {
	this := CampaignPatchableTargetChannelsInner{}
	return &this
}

// GetChannelId returns the ChannelId field value
func (o *CampaignPatchableTargetChannelsInner) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *CampaignPatchableTargetChannelsInner) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *CampaignPatchableTargetChannelsInner) SetChannelId(v string) {
	o.ChannelId = v
}

// GetInteractionId returns the InteractionId field value
func (o *CampaignPatchableTargetChannelsInner) GetInteractionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value
// and a boolean to check if the value has been set.
func (o *CampaignPatchableTargetChannelsInner) GetInteractionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.InteractionId, true
}

// SetInteractionId sets field value
func (o *CampaignPatchableTargetChannelsInner) SetInteractionId(v string) {
	o.InteractionId = v
}

// GetMain returns the Main field value if set, zero value otherwise.
func (o *CampaignPatchableTargetChannelsInner) GetMain() bool {
	if o == nil || IsNil(o.Main) {
		var ret bool
		return ret
	}
	return *o.Main
}

// GetMainOk returns a tuple with the Main field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignPatchableTargetChannelsInner) GetMainOk() (*bool, bool) {
	if o == nil || IsNil(o.Main) {
		return nil, false
	}
	return o.Main, true
}

// HasMain returns a boolean if a field has been set.
func (o *CampaignPatchableTargetChannelsInner) HasMain() bool {
	if o != nil && !IsNil(o.Main) {
		return true
	}

	return false
}

// SetMain gets a reference to the given bool and assigns it to the Main field.
func (o *CampaignPatchableTargetChannelsInner) SetMain(v bool) {
	o.Main = &v
}

func (o CampaignPatchableTargetChannelsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignPatchableTargetChannelsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["interaction_id"] = o.InteractionId
	if !IsNil(o.Main) {
		toSerialize["main"] = o.Main
	}
	return toSerialize, nil
}

type NullableCampaignPatchableTargetChannelsInner struct {
	value *CampaignPatchableTargetChannelsInner
	isSet bool
}

func (v NullableCampaignPatchableTargetChannelsInner) Get() *CampaignPatchableTargetChannelsInner {
	return v.value
}

func (v *NullableCampaignPatchableTargetChannelsInner) Set(val *CampaignPatchableTargetChannelsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignPatchableTargetChannelsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignPatchableTargetChannelsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignPatchableTargetChannelsInner(val *CampaignPatchableTargetChannelsInner) *NullableCampaignPatchableTargetChannelsInner {
	return &NullableCampaignPatchableTargetChannelsInner{value: val, isSet: true}
}

func (v NullableCampaignPatchableTargetChannelsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignPatchableTargetChannelsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


